-- name: [CS] Shantae
-- description: Shantae, the Half Genie Hero, is now playable on SM64 Coop Deluxe!\n\n\Modpack by VioletArts

local TEXT_MOD_NAME = "Shantae"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_SHANTAE_MODEL = smlua_model_util_get_id("shantae_violet_geo")

local TEX_SHANTAE_ICON = get_texture_info("shantae_violet_icon")

local SHANTAE_PALETTE = {
[PANTS] = "FF0000",
[SHIRT] = "FF0000",
[GLOVES] = "D79577",
[SHOES] = "FF0000",
[HAIR] = "B047FF",
[SKIN] = "D79577",
[CAP] = "8800D2",
[EMBLEM] = "8800D2"
}

local VOICETABLE_SHANTAE = {
    [CHAR_SOUND_ATTACKED] = 'ShantaeHurt.ogg',
    [CHAR_SOUND_DOH] = 'ShantaeDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'ShantaeDrowning.ogg',
    [CHAR_SOUND_DYING] = 'ShantaeDeath.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'ShantaeGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'ShantaeLaugh.ogg',
    [CHAR_SOUND_HAHA_2] = 'ShantaeLaugh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'ShantaeAllClear.ogg',
    [CHAR_SOUND_HOOHOO] = 'ShantaeJumping2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'ShantaeNo.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'ShantaeLetsGo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'ShantaeBurning.ogg',
    [CHAR_SOUND_OOOF] = 'ShantaeOof.ogg',
    [CHAR_SOUND_OOOF2] = 'ShantaeOof.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'ShantaeYah.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'ShantaeHah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'ShantaeHoo.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'ShantaeKill.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ShantaeFalling.ogg',
    [CHAR_SOUND_WAH2] = 'ShantaeYah.ogg',
    [CHAR_SOUND_WHOA] = 'ShantaeClimb.ogg',
    [CHAR_SOUND_YAHOO] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'ShantaeLongJump.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'ShantaeJumping1.ogg',
    [CHAR_SOUND_YAWNING] = 'ShantaeYawn.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'ShantaeLetsGo.ogg',
    [CHAR_SOUND_EEUH] = 'ShantaeLedgeGrab.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'ShantaePantingCold.ogg',
}

local charSelectLoaded = false
local function on_character_select_load()
    CT_SHANTAE = _G.charSelect.character_add("Shantae", {"Shantae, the Half Genie Hero, has", "found her way into the Mushroom Kingdom, what", "trouble is Risky causing now?!"}, "Violet", {r = 176, g = 71, b = 255}, E_SHANTAE_MODEL, CT_TOAD, TEX_SHANTAE_ICON)
    _G.charSelect.character_add_voice(E_SHANTAE_MODEL, VOICETABLE_SHANTAE)
    _G.charSelect.character_add_palette_preset(E_SHANTAE_MODEL, SHANTAE_PALETTE)

    charSelectLoaded = true
end

local function on_character_sound(m, sound)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHANTAE then return _G.charSelect.voice.sound(m, sound) end
end
local function on_character_snore(m)
    if not charSelectLoaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHANTAE then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)